%Klasyczny algorytm genetyczny
clear;
nr_gr = 1.2;  %tu wprowad nr swojej podgrupy
x_p=-2*nr_gr;  %ograniczenie dolne zmiennej
x_k=3*nr_gr;  %ograniczenie grne zmiennej
q=5;  %dokadno (liczba cyfr po przecinku)
N=20;  %liczno populacji
p_c=0.9;  %prawdopodobiestwo krzyowania
p_m=0.01;  %prawdopodobiestwo mutacji
L_gen=100;  %maksymalna liczba generacji

%deklaracje macierzy
x_opt=[0,0,0];
X=zeros(N,L_gen);
F_sr=zeros(1,L_gen);
F_min=zeros(1,L_gen);
F_max=zeros(1,L_gen);

t_start=cputime;	%pomiar czasu
 
%okrelenie dugoci chromosomu
l_odc=(x_k-x_p)*10^q;
m=ceil(log2(l_odc+1));	%minimalna liczba bitw do zakodowania zmiennej z dokadnoci q

%losowanie populacji pocztkowej
ch=round(rand(N,m));

for i=1:L_gen
    
	%dekodowanie populacji 
	x=dekoduj(ch,N,m,x_p,x_k);
    X(:,i)=x;
    
	%funkcja przystosowania pop. poczatkowej
	F=F_celu1(x);
	F_sr(i)=mean(F);		%rednia warto f. przystosowania
	F_min(i)=min(F);		%minimalna warto f. przystosowania
	F_max(i)=max(F);		%maksymalna warto f. przystosowania

    %zapamietanie najlepszego osobnika
    if F_max(i)>x_opt(2)
        ind=find(F==F_max(i));
        x_opt=[x(ind(1)),F_max(i),i];
        ch_opt=ch(ind(1),:);
    end
        
	%prawdopodobiestwa selekcji
	p_s=F/(F_sr(i)*N);

	%regua ruletki
    nr_ch=ruletka(p_s,N);

	%pula rodzicielska
	ch=ch(nr_ch,:);
 
   %krzyowanie
	ch=krzyzuj(ch,N,m,p_c);

	%mutacja
	ch=mutuj(ch,N,m,p_m);

end;

%rezultaty
fprintf('Czas dziaania algorytmu [s]: %5.2f\n',cputime-t_start);
fprintf('Najlepsze rozwizanie x_opt = %5.2f, f(x_opt) = %5.2f, znalezione w generacji: %5.0f\n',x_opt(1),x_opt(2),x_opt(3));
fprintf('F_min, F_sr, F_max ostatniej populacji:  %5.2f   -   %5.2f   -   %5.2f \n',F_min(L_gen),F_sr(L_gen),F_max(L_gen));
fprintf('F_min, F_sr, F_max wszystkich populacji:  %5.2f   -   %5.2f   -   %5.2f \n',mean(F_min),mean(F_sr),mean(F_max));
fprintf('Odchylenie standardowe funkcji przystosowania ostatniej populacji: %5.2f',std(F));

%wykresy
figure(1);
plot(1:L_gen,F_sr,1:L_gen,F_min,1:L_gen,F_max); xlabel('nr generacji'); ylabel('f(x)'); title('Przystosowanie w czasie');
figure(2);
xx=x_p:0.01:x_k;
y=F_celu1(xx);
plot(xx,y,x,zeros(N,1),'x',x_opt(1),0,'o'); xlabel('x'); ylabel('f(x)'); title('Funkcja celu i fenotypy w ostatniej generacji');
figure(3)
hist(X(:)); xlabel('x'); ylabel('Liczba chromosomw w poszczeglnych kategoriach'); title('Histogram');


